                                

{$D+,R+,P+,C-,T+,U10}
{Project #126.  Started 7/6/91.  
Create a new .WRK file for Hotwire.

                         Program : New work file
                         Version : 1.0
                        Language : Personal Pascal 2.05
                        Resource : K-Resource by Kuma
                      Written by : Merlin L. Hanson
                            Date : July 1991.      }
PROGRAM NewWork;
  {$I GEMSUBS.PAS}
  {$I AUXSUBS.PAS}
  {$I NEW_WRK.I}
  CONST        
    FirstItem = 4;    {Sized to skip WRK file header}
    cfg_fl_nm = 'NEW_WRK.CFG';
  TYPE
    s3  = string[3];
    s8  = string[8];
    s80 = string[80];
    TRez = (Low,Medium,High);
  VAR
    Printer  : text;                    {Only used for debug.}
    RSC_Name : s80;

FUNCTION MyRez:TRez;
  XBIOS(4);
  
{Display a message string on the monitor and come to an orderly halt.}
PROCEDURE Abort3(s:string); (***** First 'real' block *****)
  BEGIN{abort3}
    WriteLn(s);
    WriteLn('Press return');
    ReadLn;
    HALT;
  END{abort3};

PROCEDURE DoIt;
  TYPE 
                           (*** Components of files ***)
    T657 = PACKED ARRAY[0..643] OF char;  {4 + (8*80)}
    T555 = RECORD
             flpth: s80;
             WrkArr:T657;
           END{record};  
  VAR
    CnfigFile : FILE OF T555;     {Created by a 'Configure' run}
    NewWrk    : FILE OF T657;     {Will become HOTWIREn.WRK in the HOTWIRE directory}
    LastCh   : char;              {n for line above}
    RootName : s8;                {e.g., 'THISPRG'}
    MyPath   : s80;
 
    (*** WRK file format:                  {for reference only}  
    TYPE
      T449 = PACKED ARRAY[0..3]OF char;    {Header, 'WRK1' for level 2.1}
      T102 = PACKED ARRAY[0..79] OF char;  {a C string defining a path}
      T184 = ARRAY[0..7] OF T102;          {entries ~1 through ~8}
      T649 = RECORD
              Hdr : T449;
              Data :T184;
             END{record};  
    VAR
      WorkFile = FILE OF T649;             {with only one entry!}             
    ***)


  PROCEDURE GetDriveAndPath(VAR S:string);
    { A procedure that returns a Pascal string containing the current drive,
    current path and all punctuation.  Simply append a raw file name.}
    VAR
      i : integer;
      T : string;
      Path : string;
      DriveString : string;
    
    FUNCTION CurrentDisk:integer;
      {Returns an integer specifying the current drive. 0 specifies A, etc.}
      GEMDOS($19);
  
    PROCEDURE GetDir(VAR Ptr:string; DriveID:integer);
      {Puts a C string defining the folders currently open on DriveID
      into S.  DriveID of 0 specifies the current drive.}
      GEMDOS($47);
    
    BEGIN {getdriveandpath}
      DriveString := CONCAT(CHR(ORD('A')+CurrentDisk),':');
      GetDir(Path,0);
      {Convert from C to Pascal.}
      i := 0;
      WHILE Path[i] <> CHR(0) DO
        BEGIN
          T[i+1] := Path[i];
          i := i+1;
        END;
      {Set the length}
      T[0] := CHR(i);
      S := CONCAT(DriveString,T,'\');
    END {getdriveandpath};
   
  PROCEDURE Configure;       (***** Major *****)
    VAR
      junk  : integer;
      MyWrk : FILE OF T657;
      ArchetypeWrk : path_name;
      
    {Find the last occurance of 'ch' in a _string_.}
    FUNCTION PosLast(ch:char; s:string):integer;
      VAR i:integer;
      BEGIN
        i := LENGTH(s) + 1 ;
        REPEAT
          i := i - 1;
        UNTIL (s[i] = ch) OR (i = 0);
        PosLast := i;
      END{poslast};
    
    {                    *** Get File Name ***
    Display 'Note' above the file selector box.  Display 'Current' drive
    and path for path name. Display 's' as suggested file name.
    Return 's' as a full drive/path/file name. Force save please}
    
    PROCEDURE GetFileName(Note:string;  VAR s:path_name);
      VAR j,x_coord:integer;    MyPath:path_name;

      BEGIN{getfilename}
        Curs_Off;                 {VT-52}
        x_coord := 40 - (LENGTH(Note) DIV 2);
        GOTOXY(x_coord,1);
        InverseVideo;
        Write(Note);
        NormVideo;
        GetDriveAndPath(MyPath);
        IF GET_IN_FILE(MyPath,s)
          THEN {  }
          ELSE HALT;
        j := PosLast('\',MyPath);
        (*InputPath := MyPath;      {to global}      
        InputPath[0] := CHR( j - 1 );        {strip file-part of name}*)
        CLRSCRN;  
      END{getfilename};
          
    PROCEDURE CheckHdr;
      CONST StrK = 'WRK'; 
      VAR   i:integer;  S:s3;
      
      PROCEDURE Abort;
        VAR junk:integer;
        BEGIN
          junk := DO_ALERT(
                  '[3][File not a Hotwire .WRK file][ Well EXCUSE me ]', 1);
          HALT;        
        END{abort};
        
      BEGIN{checkhdr}
        S := StrK;
        FOR i := 0 TO 2 DO
          IF MyWrk^[i] <> S[i+1]
            THEN Abort;
      END{checkhdr};
      
    BEGIN{configure}
      ArchetypeWrk := '*.WRK';
      GetFileName(' Select a representative WRK file ',ArchetypeWrk);
      {Get a copy of the WRK file per se.}
      RESET(MyWrk,ArchetypeWrk);
      CheckHdr;
      REWRITE(CnfigFile,  CONCAT(MyPath,  cfg_fl_nm)   ); 
      CnfigFile^.flpth  := ArchetypeWrk;
      CnfigFile^.WrkArr := MyWrk^;
      PUT(CnfigFile);
      CLOSE(CnfigFile);
      junk := DO_ALERT(
              '[0][Configuration file written and closed][ OK ]', 1);
    END{configure};

  PROCEDURE CreateWrk;       (***** Major *****)
    VAR i:integer; Null:char;

    PROCEDURE GetUserInput;
      VAR
        s : str255;
        junk  : integer;
        MyBox : dialog_ptr;
        
      PROCEDURE ErrorCheck;
        VAR i:integer;  AllUnderLine:boolean;
        
        PROCEDURE Abort;
          VAR junk : integer;
          BEGIN
            junk := DO_ALERT(
              '[3][Bad input data][ Oh no! ]',   1);
            HALT;  
          END{abort};
          
        BEGIN{errorcheck}
          IF NOT (LastCh IN ['0'..'9'])
            THEN Abort;
          IF LENGTH(S) = 0
            THEN Abort;
          AllUnderline := TRUE;
          FOR i := 1 TO LENGTH(S) DO   
            BEGIN
              {AES doesn't allow for a proper set of input characters.  
              This will be a rather abrupt exit, but the user will remember it!}              
              IF S[i] = ' '              
                THEN Abort;               
              {A few underlines are OK, but really....}  
              IF S[i] <> '_' 
                THEN AllUnderLine := FALSE;  
            END;    
          IF AllUnderline
            THEN Abort;
        END{errorcheck}; 
         
      BEGIN{getuserinput}
        FIND_DIALOG(Box1,MyBox);
        CENTER_DIALOG(MyBox);
        junk := DO_DIALOG(MyBox,Nbr);
        GET_DEDIT(MyBox,Nbr,S);
        LastCh := S[1];
        GET_DEDIT(MyBox,NewName,S);
        CLrScrn;
        ErrorCheck;
        RootName := S;
      END{getuserinput};

    {Replace the root name for item 'FileNbr' with the parameter.}
    PROCEDURE ModifyOutFile(FileNbr:integer;  root:s8);
      VAR 
        FirstCh,fix,LgthExt,ix_null,ix_period,ix_slash,j:integer;
        Ext : ARRAY [1..3] OF char;
      
      {Starting at 'start' find the first occurance of 'ch', 
      much like POS does for strings.}
      FUNCTION PosCh(ch:char; Start:integer):integer;
        VAR i:integer;
        BEGIN
          i := Start;
          REPEAT
            i := i + 1;
          UNTIL (NewWrk^[i] = ch);
          PosCh := i;
        END{posch};
        
      {Search the array backwards for 'ch', starting at 'i'.}
      FUNCTION PosLast(ch:char; i:integer):integer;
        BEGIN
          REPEAT
            i := i - 1;
          UNTIL (NewWrk^[i] = ch) OR (i = 0);
          PosLast := i;
        END{poslast};
        
      {Concatenate 'ch' to the evolving file name; THEN increment the
      file index, 'fix'.  This is the onlu entity allowed to manipulate
      fix after it has been initialized!}
      PROCEDURE Catenate(ch:char);
        BEGIN
          NewWrk^[fix] := ch;
          fix := fix + 1;
        END{catenate};
                    
      BEGIN{modifyoutfile}
        FirstCh  := FirstItem + (FileNbr * 80);
        IF (NewWrk^[FirstCh] = Null)
          THEN {nothing to do}
          ELSE
            BEGIN
              ix_null   := PosCh(Null,FirstCh); 
              ix_period := PosCh('.',FirstCh);
              ix_slash  := PosLast('\',ix_null);  {The _last_ one.}
              {Save the maximum sized extender.}
              FOR j := 1 TO 3 DO
                Ext[j] := NewWrk^[ix_period + j];
              fix := ix_slash + 1;  
              {Replace the 'root-part'} 
              FOR j := 1 TO LENGTH(Root) DO
                Catenate(Root[j]);
              Catenate('.');
              LgthExt := ix_null - ix_period - 1;
              FOR j := 1 TO LgthExt DO
                Catenate(Ext[j]);
              Catenate(Null);           (*And so: file name must be < 80 char*)
            END;  
      END{modifyoutfile};        
      
    BEGIN{creatework}
      GetUserInput;
      Null := CHR(0);
      {Assign the file containing the configuration information
      and read the first (and only) record.}
      RESET(CnfigFile,    CONCAT(MyPath, cfg_fl_nm)  );
      WITH CnfigFile^ DO
        BEGIN
          i := POS('.',flpth);
          flpth[i - 1] := LastCh;
          {Assert: the string 'flpth' has the full identity of the 
          WRK file to be created.  Erase any file with that name.}
          REWRITE(NewWrk,(*'A:\NEWWRK'*) flpth);
          {Next statement creates 95% of the new file.  Including lots of nulls.  
          Then edit whatever is different.}
          NewWrk^ := WrkArr;           (******)
        END{with};  
      {Now modify the file}
      FOR i := 0 TO 7 DO
        ModifyOutFile(i,RootName);   
      {Assert: NewWrk^ points at a completely modified WRK file.}  
    END{createwrk};
    
  PROCEDURE WriteWork;
    VAR junk:integer;
    BEGIN
      PUT(NewWrk);  
      CLOSE(NewWrk);    
      junk := DO_ALERT(
              CONCAT('[0][Go to another HOTWIRE menu|',
                         'and then return to invoke|',
                         '       the new menu     ][ OK ]'  ),  1);
    END{writework};
    
  BEGIN{doit}           (***** Outermost procedure *****)
    GetDriveAndPath(MyPath);
    IF DO_ALERT(
      '[0][   Configure?   ][ Yes | No ]',2) = 1
      THEN Configure
      ELSE
        BEGIN       {\create a new WRK file per user dialog.}
          CreateWrk;    
          WriteWork;
        END;  
  END{doit};
  
BEGIN {program}
  ClrScrn;                              {VT-52}
  REWRITE(Printer,'PRN:');
  IF INIT_GEM >= 0
    THEN 
      BEGIN
        CASE MyRez OF
          Low    : HALT;
          Medium : RSC_Name := 'NEW_WRKC.RSC';     
          High   : RSC_Name := 'NEW_WRKM.RSC';
        END{case};  
        IF LOAD_RESOURCE(Rsc_Name)
          THEN DoIt
          ELSE Abort3('Can''t find RSC file.');
        EXIT_GEM;
      END;  
END{program}.  
